#include <math.h>
#include <stdio.h>
#include <strings.h>

float atof(), getfloat();
FILE *fi;
double mtof(), ftom();
char *getstring(), *getstring2();
int osc_voicenum, osc_pitch, osc_tabno, osc_amp1, osc_amp2,
	osc_time1, osc_time2;
float osc_vibdepth, osc_vibfreq;
int syn_which;
#define SYN_OSC 1
#define SYN_CHAPO 2
#define SYN_SAMP 3

main(argc,argv)
 int argc;
 char *argv[];
{
	float fs, percnt, intval, xf;
	int f,ilun,iosc,i,n,n1,n2,c, cminus, nwt,
		timenow, eventnum = -1, beatnow = -1;
	char car, nstr[10];
/* check command string : PROG filin filout  (3 arguments) */
	if (argc != 2){
		printf("Usage: PROG filin\n");
		exit(1);
		}
/* test sur filin: existe? si oui, ouvrir, sinon exit */
	if ((fi=fopen (argv[1],"r"))==NULL){
		printf("ERR: le fichier %s n'existe pas\n",argv[1]);
		exit(1);
		}

	while (1) 
	{
		fscanf(fi,"%s",nstr);
		
#ifdef OBSOLETE
		if (nstr[0] == 'B')
		{
			flushnote();
			fscanf(fi,"%d %d",&n1,&n2); 	/*read and flush n2*/
			if (n1 > beatnow)
			{
				eventnum++;
				if (eventnum == 0)
					printf("0 1 ------------------------ 10;\n");
				else if (eventnum != 1)
					printf("0 %d ------------------------ %d;\n",
						eventnum, n1);
				beatnow = n1;
				timenow = 0;
			}
		}
		else
#endif OBSOLETE
		if (nstr[0] == 'b' || nstr[0] == 'B')
		{
			flushnote();
			fscanf(fi,"%d %d",&n1,&n2);
			if (n1 > beatnow)
			{
				eventnum++;
				/* if (eventnum == 0)
					printf("0 1 ------------------------ 10;\n");
				else if (eventnum != 1) */
				printf("0 %d ------------------------ %d;\n",
					eventnum, n1);
				beatnow = n1;
				timenow = 0;
			}
			if (nstr[0] == 'b')
			{
				if (n2 > timenow)
				{
					printf("%d ", n2 - timenow);
					timenow = n2;
				}
				else if (n2 < timenow) error("event out of order");
			}
		}
		/************* pour harmonizers, delays et reverb ***************/
		
		else if (nstr[0] == 't')	/* hfreq[n] Transposition */
		{
			int down, nsteps, quarter, which = getint();
			char *str = getstring();
			down = (str[0] == 'U' ? 1 : -1);
			if (sscanf(str + 1, "%d", &nsteps) < 1)
				error("bad harmonizer interval: %s", str);
			quarter = (str[strlen(str)-1] == 'Q');
			printf("trans%d %d;\n", which, 100 * down * nsteps + 50 * quarter);
		}
		else if (nstr[0] == 'g')	/* couper harmonizer: hgain[n] F */
			printf("hamp%d 0;\n", getint()+1);
		else if (nstr[0] == 'R')		/* R n --> revgate n */
			printf("revgate %d;\n", getamp());
		else if (nstr[0] == 'r')	/* r REVI --> revgn REVI revlp REVLPI */
		{
			char *s = getstring();
			if (!strcmp(s, "I")) printf("revfb 127;\n");
			else if (!strcmp(s, "D")) printf("revfb REVDAMP%d;\n", getint());
		}
		
			/****** frequency shifters: +|- F or  +|- T <pitchMIDI> *****/
		else if (nstr[0] == '+' || nstr[0] == '-' )
		{
			char *s = getstring();
			if (s[0] == 'F')
			{
				if (nstr[0] == '+') printf("fpos F;\nrtof F;\nftor F;\n");
				else printf("fneg F;\nrtof F;\nftor F;\n");
			}
			else if (s[0] == 'T')
			{
				int xx = getint();
				if (xx > 20) fs = xx;
				else fs = ftom((float)xx);
				if (nstr[0] == '+')
					printf("fpos T;\nfsfre %d;\n", (int)(fs));
				else printf("fneg T;\nfsfre %d;\n", (int)(fs));
			}
		}
	
			/****	Codes precedes par un '.'	****/
		else if (!strcmp(nstr, ".rf")) printf("rtof %s;\n", getstring());
		else if (!strcmp(nstr, ".fr")) printf("ftor %s;\n", getstring());
		else if (!strcmp(nstr, ".hr")) printf("htor %s;\n", getstring());
		else if (!strcmp(nstr, ".rh")) printf("rtoh %s;\n", getstring());
		else if (!strcmp(nstr, ".hf")) printf("htof %s;\n", getstring());
		else if (!strcmp(nstr, ".fh")) printf("ftoh %s;\n", getstring());
		else if (!strcmp(nstr, ".dr")) printf("dtor %s;\n", getstring());
		else if (!strcmp(nstr, ".dh")) printf("dtoh %s;\n", getstring());
		else if (!strcmp(nstr, ".df")) printf("dtof %s;\n", getstring());
		else if (!strcmp(nstr, ".sr")) printf("stor %s;\n", getstring());
		else if (!strcmp(nstr, ".sh")) printf("stoh %s;\n", getstring());
		else if (!strcmp(nstr, ".sf")) printf("stof %s;\n", getstring());
		else if (!strcmp(nstr, ".cf")) printf("stof %s;\n", getstring());
	
		/******* additive synthesis *****/
		else if (nstr[0] == 'f')		
		{
			flushnote();
			osc_voicenum = getint();
			if (strcmp(getstring(), "m")) error("f sequence");
			osc_pitch = getint();
		}
		else if (nstr[0] == 'd')		/* vibrato depth */
		{
			checknote();
			if (strcmp(getstring(), "p"))	
				error("d not followed by p");
			osc_vibdepth = getfloat();
		}
		else if (nstr[0] == 'w')		/* wavetable number */
		{
			int voiceno = getint();
			if (voiceno <= 16)
			{
				if (voiceno != osc_voicenum) error("w: wrong voice");
				osc_tabno = getint();
			}
			else printf("chapo-tab %d;\n", getint());
		}
		else if (nstr[0] == 'v')		/* vibrato speed (HZ.) */
		{
			checknote();
			osc_vibfreq = getfloat();
		}
			/* luni increment.  Always followed by
				[PN] <voicenum> e <dynamic> <same voicenum> */
		else if (nstr[0] == 'i')
		{
			char *str = getstring();
			if (!strcmp(str, "P"))
			{
				checknote();
				osc_amp1 = osc_amp2 = 127;
				osc_time1 = osc_time2 = 10;
					/* it was actually 1 msec on the 4x */
				if (strcmp(getstring(), "e")) error("bad i sequence (1)");
				osc_amp1 = osc_amp2 = getamp();
				checknote();
			}
			else if (!strcmp(str, "N"))
			{
				int voiceno = getint();
				flushnote();
				printf("addsyn %d 0 100 0 100;\n",voiceno+1);
				if (strcmp(getstring(), "e")) error("bad i sequence (3)");
				str = getstring();
				if (strcmp(str, "n") && strcmp(str, "N"))
					error("bad i sequence (4)");
				getint();
			}
			else error("bad i sequence (5)");
		}
		else if (nstr[0] == 'E')
		{
			if (osc_pitch)
			{
				float nothing, zip;
				checknote();
				nothing = getfloat();
				osc_time1 = 1000 * getfloat();
				osc_amp1 = 127.5 + 10 * log(getfloat())/log(2.);
				osc_time2 = 1000 * getfloat();
				osc_amp2 = 127.5 + 10 * log(getfloat())/log(2.);
				zip = getfloat();
				if (zip != 0) error("E sequence (1)");
			}
			else
			{
				int voiceno = getint(), dectime;
				char *str;
				flushnote();
				getstring();
				dectime = getfloat() * 1000 + .5;
				if (getint() || getint())
					error ("E sequence (2)");
				printf("addsyn %d 0 %d 0 100;\n",voiceno+1,
					dectime);
			}
		}
		
				/* synth to harms */
		else if (nstr[0] == 'H') printf("STOHARMS%d ", getint());
		else if (nstr[0] == 'L') printf("%s ", getstring()); /* literal */
		else if (nstr[0] == 'U')	/* update */
		{
			char *s = getstring();
			if (!strcmp(s, "porta"))
			{
				int waka;
				s = getstring();
				if (!strcmp(s, "T")) printf("porta 0;\n");
				else if (sscanf(s, "%x", &waka) >= 1 && waka)
					printf("porta %d;\n", 8388608/(32*waka));
				else error("bad portamento");
			}
			else printf("%s %d;\n", s, getamp());
		}
		else if (nstr[0] == 'C')		/* chapo frequencies */
		{
			int which = getint();
			float freq = getfloat();
			if (syn_which != SYN_CHAPO && eventnum > 0)
				printf("which-synth %d;\n", syn_which = SYN_CHAPO);
			printf("chapo %d %f;\n", which, freq);
		}
		else if (nstr[0] == 'x')		/* fin */
		{
			break;
		}
		else error("unknown command: %s", nstr);
	
	} /* end of loop */
	printf("\n0 %d ",eventnum + 1);
	printf("------------------------ 10000;\n");
	fclose (fi);
	exit(0);
}

float getfloat()
{
	float x;
	char str[100];
	if (fscanf(fi, "%s", str) < 1)
	{
		fprintf(stderr, "missing number\n");
		exit(1);
	}
	if (*str >= 'a' && *str <= 'z')
	{
		if (!strcmp(str, "fff")) x = 1./8;
		else if (!strcmp(str, "ff")) x = 1./16;
		else if (!strcmp(str, "f")) x = 1./32;
		else if (!strcmp(str, "p")) x = 1./64;
		else if (!strcmp(str, "pp")) x = 1./128;
		else 
		{
			error("bad dynamic");
			return (0);
		}
	}
	else if (sscanf(str, "%f", &x) < 1)
	{
		error("bad number");
		return (0);
	}
	return (x);
}

error(s, a, b, c)
 char *s;
{
	int where = ftell(fi), i, line;
	rewind(fi);
	for (i = 0, line = 1; i < where; i++)
		if (getc(fi) == '\n') line++;
	fprintf(stderr, "line %d: ", line);
	fprintf(stderr, s, a, b, c);
	fprintf(stderr, "\n");
}

double mtof(f)
 double f;
{
	return (440. * exp(.057762265 * (f - 69.)));
}

double ftom(f)
 double f;
{
	if (f > 0) return (69. + (1./.057762265) * log(f/440.));
	else return (-1000);
}

char *getstring()
{
	static char buf[100];
	fscanf(fi,"%s",buf);
	return (buf);
}

char *getstring2()
{
	static char buf[100];
	fscanf(fi,"%s",buf);
	return (buf);
}

getint()
{
	int rats = 0;
	static char buf[100];
	fscanf(fi,"%s",buf);
	if (sscanf(buf,"%d", &rats) < 1) error("bad decimal int: %s", buf);
	return (rats);
}

getamp()
{
	int rats = 0;
	static char buf[100];
	fscanf(fi,"%s",buf);
	if (!strcmp(buf, "F")) rats = 0;
	else if (!strcmp(buf, "T")) rats = 0x800000;
	else if (!strcmp(buf, "H")) rats = 0x400000;
	else if (!strcmp(buf, "Q")) rats = 0x200000;
	else if (!strcmp(buf, "fff")) rats = 0x800000/8;
	else if (!strcmp(buf, "ff")) rats = 0x800000/16;
	else if (!strcmp(buf, "f")) rats = 0x800000/32;
	else if (!strcmp(buf, "p")) rats = 0x800000/64;
	else if (!strcmp(buf, "pp")) rats = 0x800000/128;
	else if (sscanf(buf,"%x", &rats) < 1) error("bad amplitude: %s", buf);
	if (rats <= 0) return 0;
	else return ((int)(127.5 +
		 10 * (log(rats) - log((float)0x800000))/log(2.)));
}

flushnote()
{
	if (osc_pitch)
	{
		if (syn_which != SYN_OSC)
			printf("which-synth %d;\n", syn_which = SYN_OSC);
		printf("addsyn %d %d %d %d %d %d %f %f %d;\n",
			osc_voicenum+1, osc_amp1, osc_time1,
			osc_amp2, osc_time2,
			100 * osc_pitch, osc_vibdepth * mtof((float)osc_pitch),
			osc_vibfreq, osc_tabno);
		osc_voicenum = -1;
		osc_pitch = osc_amp1 = osc_time1 = osc_amp2 =
			osc_time2 = 0;
		osc_vibdepth = osc_vibfreq = 0;
	}
}

checknote()
{
	if (getint() != osc_voicenum) error("checknote failed");
}

/***********************************************************
cv.c - Construction des fichiers d'update pour Max.
	(these are Battier's comments.... )
Codes generaux
--------------
B nnn n		ecrit les initialisations;
		ex: B 100 0

b nnn n		entete de definition d'action.
		commencer chaque nouvelle definition d'action
		par ce code; il s'applique si les temps incrementaux ont
		change;
		Le programme 'genupd' produit une liste d'entetes; on donne
		l'etiquette de debut, de fin, et l'increment.

x		termine la partition.

Harmonizers
-----------
t n  Un|Dn		==	hgain[n] T	 hfreq[n] Un|Dn
				hdel[n] <MSdelay>
	- transposition U (Up) ou D (Down) de n 1/2 tons ou 1/4 de tons
	- MSdelay: delai en millisecondes, 
		lu dans le champ 'n' de l'ordre 'b nnn n'.

g n			==	hgain[n] F
	- couper le gain de l'harmonizer N

Frequency Shifters
------------------
les frequences sont donnees en hauteur MIDI (PitchMIDI); pour les modulations
d'amplitudes, les tres basses frequences sont donnees en Hertz (frequences 
inferieures au pitchMIDI 21.

+ F		== 	ctof F 	R2_fpos F	R2_rtof F	R2_ftor F
- F		== 	ctof F 	R2_fneg F	R2_rtof F	R2_ftor F
+ T <PitchMIDI>	== 	ctof F	R2_fpos T 	R2_fshift <Hexa>
- T <PitchMIDI>	== 	ctof F 	R2_fneg T 	R2_fshift <Hexa>

Reverberations
--------------
R n		==	revgate n
 
r REVI		==	revgn REVI	 revlp REVLPI
r REVD 		==	revgn REVD	 revlp REVLPD

Synthese additive
-----------------
f n h|m		==	fre[n] <hexa>
		h =	frequence en Hz
		m =	pitch MIDI

d n p|a		==	v_depth[n] <hexa>
		p =	pourcentage de la frequence centrale
		a =	valeur absolue en Hz

v n <freqHz>	==	v_vit[n] <hexa>

w n {1,16}	==	selection d'une wavetable #{1,16}
			wt[0,15] <hexa>

Codes de liaison entre modules (XtoY) (toujours suivis de T ou F)
------------------------------------
	.cf T|F	==	R2_ctof T|F
	.df	==	R2_dtof
	.dh	==	R1_dtoh
	.dr	==	R2_dtor
	.fr	==	R2_ftor
	.hr	==	R2_htor
	.hf	==	htof
	.rf	==	R2_rtof
	.rh	==	R1_rtoh
	.sr	==	stor
	.sh	==	stoh
	.sf	==	stof

syntaxe 
-------
$cv	 UpdateFile(fichier entree)	 UpdateFile.a(fichier sortie)

Codes utilises pour les Update lists
------------------------------------
('*' utilises a l'interieur d'un autre code)
a*, b, B, c, d, D, e, E*, f, F*, g, h, i, m, p*, r, R, t, T*, v, w
+*, -*, ., .fr, .rf

*****************************************************************/






