int header[] =  {0x2e736e64, 0x0000001c, 0x10000000, 0x00000003, 0x0000ac44,
	0x00000001, 0x62617a00};

#include "stdio.h"
#include "math.h"
#define NPOINTS 512

#define BYTES (2*NPOINTS)
#define TEST 256
#define NS 16

float pha[NS];

#define SS 16384
float sines[SS];

float build();
float fbuf[NPOINTS];

main(argc, argv)
 char **argv;
{
	short sbuf[NPOINTS];
	int i = 0, sfd;
	char *name;
	short buf[NPOINTS];
	float m = build(TEST);
	int j, nochange = 0;
	float grain = .1;
	m = 0x7fff/m;
	for (j = 0; j < NS; j++) pha[j] = ((123 * j * j + 5218*j)%700)/11.;
	for (j = 0; j < SS; j++) sines[j] = sin((2*3.14159/SS)*j);
	while (1)
	{
		float was = pha[i], tmp;
		pha[i] += grain;
		if ((tmp = build(TEST)) < m)
		{
			nochange = 0;
			m = tmp;
			fprintf(stderr, "%f\n", m);
			continue;
		}
		pha[i] = was - grain;
		if ((tmp = build(TEST)) < m)
		{
			nochange = 0;
			m = tmp;
			fprintf(stderr, "%f\n", m);
			continue;
		}
		pha[i] = was;
		if ((++nochange) == NS) break;
		i ++;
		i %= NS;
	}
	m = build(NPOINTS);
	fprintf(stderr, "%f\n", m);
	m = 0x4000/m;
	for (i = 0; i < NPOINTS; i++) sbuf[i] = fbuf[i] * m;
	if (write(1, header, sizeof(header)) < sizeof(header) ||
		write(1, sbuf, sizeof(sbuf)) < sizeof(sbuf))
	{
		perror("write");
		exit(1);
	}
	exit(0);
}

float build(size)
{
	int i, j;
	float m = 0, norm = (1./size);
	for (i = 0; i < size; i++)
	{
		float foo = .5;
		for (j = 0; j < NS; j++)
			foo += 
			sines[(int)(SS * ((j+1)*i*norm + pha[j])) & (SS-1)];
		fbuf[i] = foo;
	}
	for (i = 0; i < size; i++)
	{
		if (fbuf[i] > m) m = fbuf[i];
		else if (-fbuf[i] > m) m = -fbuf[i];
	}
	/* fprintf(stderr, "- %f\n", m); */
	return (m);
}
