int header[] =  {0x2e736e64, 0x0000001c, 0x10000000, 0x00000003, 0x0000ac44,
	0x00000001, 0x62617a00};

#include "stdio.h"
#include "math.h"
#define NPOINTS 512
#define MAXPARTIAL 50

main(argc, argv)
 char **argv;
{
	float fbuf[NPOINTS];
	short sbuf[NPOINTS];
	float strengths[MAXPARTIAL], amp = 0;
	int i, j, n = 0;
	argc--; argv++;
	if (argc > MAXPARTIAL)
	{
		fprintf(stderr, "max. %d allowed\n",  MAXPARTIAL);
		exit(1);
	}
	while (argc > 0)
	{
		if (sscanf(*argv, "%f", &strengths[n]) < 1)
		{
			fprintf(stderr, "bad argument: %s\n",  *argv);
			exit(1);
		}
		n++;
		argc--; argv++;
	}
	for (i = 0; i < NPOINTS; i++)
	{
		fbuf[i] = 0;
		for (j = 0; j < n; j++)
			fbuf[i] += strengths[j] * sin(2*3.14159*i*(j+1)/NPOINTS);
		if (fbuf[i] > amp) amp = fbuf[i];
		else if (-fbuf[i] > amp) amp = -fbuf[i];
	}
	if (amp > 0) amp = 1./amp;
	for (i = 0; i < NPOINTS; i++) sbuf[i] = amp * fbuf[i] * 32767.;
	if (write(1, header, sizeof(header)) < sizeof(header) ||
		write(1, sbuf, sizeof(sbuf)) < sizeof(sbuf))
	{
		perror("write");
		exit(1);
	}
	exit(0);
}
